Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QDataStream

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QDataStream

All Implemented Interfaces:
  QtJambiInterface

    public class QDataStream

extends QtJambiObject

The `QDataStream` class provides serialization of binary data to a `QIODevice`. A data stream is a binary stream of encoded information which is 100% independent of the host computer's operating system, CPU or byte order. For example, a data stream that is written by a PC under Windows can be read by a Sun SPARC running Solaris.

You can also use a data stream to read/write `raw unencoded binary data`. If you want a "parsing" input stream, see `QTextStream`.

The `QDataStream` class implements the serialization of C++'s basic data types, like `char`, `short`, `int`, `char *`, etc. Serialization of more complex data is accomplished by breaking up the data into primitive units.

A data stream cooperates closely with a `QIODevice`. A `QIODevice` represents an input/output medium one can read data from and write data to. The `QFile` class is an example of an I/O device.

Example (write binary data to a stream):

            QFile file = new QFile("file.dat");
            QFile.OpenMode mode = new QFile.OpenMode();
            mode.set(QFile.OpenModeFlag.WriteOnly);
            file.open(mode);
            QDataStream out = new QDataStream(file);   // we will serialize the data into the file
            out.writeString("the answer is");   // serialize a string
            out.writeInt(42);        // serialize an integer

Example (read binary data from a stream):

            QFile file = new QFile("file.dat");
            QFile.OpenMode mode = new QFile.OpenMode();
            mode.set(QFile.OpenModeFlag.ReadOnly);
            file.open(mode);
            QDataStream in = new QDataStream(file);    // read the data serialized from the file
            // extract "the answer is" and 42
            String str = in.readString();
            int a = in.readInt();

Each item written to the stream is written in a predefined binary format that varies depending on the item's type. Supported Qt types include `QBrush`, `QColor`, `QDateTime`, `QFont`, `QPixmap`, QString, `QVariant` and many others. For the complete list of all Qt types supporting data streaming see the Format of the QDataStream operators.

For integers it is best to always cast to a Qt integer type for writing, and to read back into the same Qt integer type. This ensures that you get integers of the size you want and insulates you from compiler and platform differences.

To take one example, a `char *` string is written as a 32-bit integer equal to the length of the string including the '\0' byte, followed by all the characters of the string including the '\0' byte. When reading a `char *` string, 4 bytes are read to create the 32-bit length value, then that many characters for the `char *` string including the '\0' terminator are read.

The initial I/O device is usually set in the constructor, but can be changed with `setDevice()`. If you've reached the end of the data (or if there is no I/O device set) `atEnd()` will return true.

## Versioning

`QDataStream`'s binary format has evolved since Qt 1.0, and is likely to continue evolving to reflect changes done in Qt. When inputting or outputting complex types, it's very important to make sure that the same version of the stream (`version()`) is used for reading and writing. If you need both forward and backward compatibility, you can hardcode the version number in the application:

            stream.setVersion(QDataStream.Version.Qt_4_0.value());

If you are producing a new binary data format, such as a file format for documents created by your application, you could use a `QDataStream` to write the data in a portable format. Typically, you would write a brief header containing a magic string and a version number to give yourself room for future expansion. For example:

            QFile file = new QFile("file.xxx");
            QFile.OpenMode mode = new QFile.OpenMode();
            mode.set(QFile.OpenModeFlag.WriteOnly);
            file.open(mode);
            QDataStream out = new QDataStream(file);

            // Write a header with a "magic number" and a version
            out.writeInt(0xA0B0C0D0);
            out.writeInt(123);

            out.setVersion(QDataStream.Version.Qt_4_0.value());

            // Write the data
            out.writeBytes(lots_of_interesting_data.toByteArray());

Then read it in with:

            QFile file = new QFile("file.xxx");
            QFile.OpenMode mode = new QFile.OpenMode();
            mode.set(QFile.OpenModeFlag.ReadOnly);
            file.open(mode);
            QDataStream in = new QDataStream(file);

            // Read and check the header
            int magic = in.readInt();
            if (magic != 0xA0B0C0D0)
                return XXX_BAD_FILE_FORMAT;

            // Read the version
            int version = in.readInt();
            if (version < 100)
                return XXX_BAD_FILE_TOO_OLD;
            if (version > 123)
                return XXX_BAD_FILE_TOO_NEW;

            if (version <= 110)
                in.setVersion(QDataStream.Version.Qt_3_1.value());
            else
                in.setVersion(QDataStream.Version.Qt_4_0.value());

            // Read the data
            QByteArray lots_of_interesting_data = new QByteArray();
            QByteArray data_new_in_XXX_version_1_2 = new QByteArray();
            QByteArray other_interesting_data = new QByteArray();

            lots_of_interesting_data.readFrom(in);
            if (version >= 120)
                data_new_in_XXX_version_1_2.readFrom(in);
            other_interesting_data.readFrom(in);

You can select which byte order to use when serializing data. The default setting is big endian (MSB first). Changing it to little endian breaks the portability (unless the reader also changes to little endian). We recommend keeping this setting unless you have special requirements.

## Reading and writing raw binary data

You may wish to read/write your own raw binary data to/from the data stream directly. Data may be read from the stream into a preallocated `char *` using readRawData(). Similarly data can be written to the stream using writeRawData(). Note that any encoding/decoding of the data must be done by you.

A similar pair of functions is `readBytes()` and `writeBytes()`. These differ from their raw counterparts as follows: `readBytes()` reads a quint32 which is taken to be the length of the data to be read, then that number of bytes is read into the preallocated `char *`; `writeBytes()` writes a quint32 containing the length of the data, followed by the data. Note that any encoding/decoding of the data (apart from the length quint32) must be done by you.

See also:
  `QTextStream`, and `QVariant`.

Nested Class Summary
`static class` | `QDataStream.Status` This enum describes the current status of the text stream.
`static class` | `QDataStream.Version` This class has no available documentation.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QDataStream()` Constructs a data stream that has no I/O device.
`QDataStream(QByteArray arg__1)` Constructs a read-only data stream that operates on byte array `a`.
`QDataStream(QByteArray a, QIODevice.OpenMode mode)` Constructs a data stream that operates on a byte array, `a`.
`QDataStream(QByteArray a, QIODevice.OpenModeFlag[] mode)` Constructs a data stream that operates on a byte array, `a`.
`QDataStream(QIODevice arg__1)` Constructs a data stream that uses the I/O device `d`.

Method Summary
`boolean` | `atEnd()` Returns true if the I/O device has reached the end position (end of the stream or file) or if there is no I/O device set; otherwise returns false.
`QIODevice` | `device()` Returns the I/O device currently set.
`boolean` | `readBoolean()` This function reads a boolean from the stream.
`byte` | `readByte()` This function read a byte from the stream.
`int` | `readBytes(byte[] buffer)` Reads data from the stream and puts the data in `buffer`.
`int` | `readBytes(byte[] buffer, int length)` Reads `length` bytes from the stream, and puts them in `buffer`.
`char` | `readChar()` Reads a character from the stream.
`double` | `readDouble()` This function read a double from the stream.
`float` | `readFloat()` This function reads a float from the stream.
`int` | `readInt()` This function reads an int from the stream.
`long` | `readLong()` This function reads a long from the stream.
`short` | `readShort()` This function reads a short from the stream.
`java.lang.String` | `readString()` This function reads a string from the stream.
`void` | `resetStatus()` Resets the status of the data stream.
`void` | `setDevice(QIODevice arg__1)` void QDataStream.:setDevice(`QIODevice` *d)
`void` | `setStatus(QDataStream.Status status)` Sets the status of the data stream to the `status` given.
`void` | `setVersion(int arg__1)` Sets the version number of the data serialization format to `v`.
`int` | `skipRawData(int len)` Skips `len` bytes from the device.
`QDataStream.Status` | `status()` Returns the status of the data stream.
`void` | `unsetDevice()` Unsets the I/O device.
`int` | `version()` Returns the version number of the data serialization format.
`QDataStream` | `writeBoolean(boolean i)` Writes a boolean value, `i`, to the stream.
`QDataStream` | `writeByte(byte i)` Writes the byte `i` to the stream.
`int` | `writeBytes(byte[] buffer)` Writes the bytes in `data` to the stream, This function returns the bytes written or -1 if an error occurred.
`int` | `writeBytes(byte[] buffer, int length)` Writes `length` bytes from `data`.
`QDataStream` | `writeDouble(double f)` Writes a 64-bit floating point number, `f`, to the stream using the standard IEEE 754 format.
`QDataStream` | `writeFloat(float f)` Writes a 32-bit floating point number, `f`, to the stream using the standard IEEE 754 format.
`QDataStream` | `writeInt(int i)` Writes a signed byte, `i`, to the stream and returns a reference to the stream.
`QDataStream` | `writeLong(long i)` Writes a signed 64-bit integer, `i`, to the stream and returns a reference to the stream.
`QDataStream` | `writeShort(short s)` This function writes the short `s/tt> to the stream.`
`void` | `writeString(java.lang.String string)` This function writes the short `s/tt> to the stream.`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QDataStream

    public QDataStream()

  Constructs a data stream that has no I/O device.

See also:
  `setDevice()`.

### QDataStream

    public QDataStream(QIODevice arg__1)

  Constructs a data stream that uses the I/O device `d`.

  Warning: If you use QSocket or QSocketDevice as the I/O device `d` for reading data, you must make sure that enough data is available on the socket for the operation to successfully proceed; `QDataStream` does not have any means to handle or recover from short-reads.

See also:
  `setDevice()`, and `device()`.

### QDataStream

    public QDataStream(QByteArray arg__1)

  Constructs a read-only data stream that operates on byte array `a`. Use `QDataStream`(`QByteArray`*, int) if you want to write to a byte array.

  Since `QByteArray` is not a `QIODevice` subclass, internally a `QBuffer` is created to wrap the byte array.

### QDataStream

    public QDataStream(QByteArray a,
                       QIODevice.OpenMode mode)

  Constructs a data stream that operates on a byte array, `a`. The `mode` describes how the device is to be used.

  Alternatively, you can use `QDataStream`(const `QByteArray` &) if you just want to read from a byte array.

  Since `QByteArray` is not a `QIODevice` subclass, internally a `QBuffer` is created to wrap the byte array.

### QDataStream

    public QDataStream(QByteArray a,
                       QIODevice.OpenModeFlag[] mode)

  Constructs a data stream that operates on a byte array, `a`. The `mode` describes how the device is to be used.

  Alternatively, you can use `QDataStream`(const `QByteArray` &) if you just want to read from a byte array.

  Since `QByteArray` is not a `QIODevice` subclass, internally a `QBuffer` is created to wrap the byte array.

Method Detail

### atEnd

    public final boolean atEnd()

  Returns true if the I/O device has reached the end position (end of the stream or file) or if there is no I/O device set; otherwise returns false.

See also:
  `QIODevice::atEnd()`.

### device

    public final QIODevice device()

  Returns the I/O device currently set.

See also:
  `setDevice()`, and unsetDevice().

### writeBoolean

    public final QDataStream writeBoolean(boolean i)

  Writes a boolean value, `i`, to the stream. Returns a reference to the stream.

### writeDouble

    public final QDataStream writeDouble(double f)

  Writes a 64-bit floating point number, `f`, to the stream using the standard IEEE 754 format. Returns a reference to the stream.

### writeFloat

    public final QDataStream writeFloat(float f)

  Writes a 32-bit floating point number, `f`, to the stream using the standard IEEE 754 format. Returns a reference to the stream.

### writeInt

    public final QDataStream writeInt(int i)

  Writes a signed byte, `i`, to the stream and returns a reference to the stream.

### writeLong

    public final QDataStream writeLong(long i)

  Writes a signed 64-bit integer, `i`, to the stream and returns a reference to the stream.

### writeByte

    public final QDataStream writeByte(byte i)

  Writes the byte `i` to the stream. `i`

### resetStatus

    public final void resetStatus()

  Resets the status of the data stream.

See also:
  `Status` , `status()`, and `setStatus()`.

### setDevice

    public final void setDevice(QIODevice arg__1)

  void QDataStream.:setDevice(`QIODevice` *d)

  Sets the I/O device to `d`.

See also:
  `device()`, and unsetDevice().

### setStatus

    public final void setStatus(QDataStream.Status status)

  Sets the status of the data stream to the `status` given.

See also:
  `Status` , `status()`, and `resetStatus()`.

### setVersion

    public final void setVersion(int arg__1)

  Sets the version number of the data serialization format to `v`.

  You don't have to set a version if you are using the current version of Qt, but for your own custom binary formats we recommend that you do; see `Versioning` in the Detailed Description.

  In order to accommodate new functionality, the datastream serialization format of some Qt classes has changed in some versions of Qt. If you want to read data that was created by an earlier version of Qt, or write data that can be read by a program that was compiled with an earlier version of Qt, use this function to modify the serialization format used by `QDataStream`.

  Qt Version | `QDataStream` Version
  --- | ---
  Qt 4.4 | 10
  Qt 4.3 | 9
  Qt 4.2 | 8
  Qt 4.0, 4.1 | 7
  Qt 3.3 | 6
  Qt 3.1, 3.2 | 5
  Qt 3.0 | 4
  Qt 2.1, 2.2, 2.3 | 3
  Qt 2.0 | 2
  Qt 1.x | 1

  The `Version` enum provides symbolic constants for the different versions of Qt. For example:

              QDataStream out = new QDataStream(file);
              out.setVersion(QDataStream.Version.Qt_4_0.value());

See also:
  `version()`, and `Version` .

### skipRawData

    public final int skipRawData(int len)

  Skips `len` bytes from the device. Returns the number of bytes actually skipped, or -1 on error.

  This is equivalent to calling readRawData() on a buffer of length `len` and ignoring the buffer.

See also:
  `QIODevice::seek()`.

### status

    public final QDataStream.Status status()

  Returns the status of the data stream.

See also:
  `Status` , `setStatus()`, and `resetStatus()`.

### unsetDevice

    public final void unsetDevice()

  Unsets the I/O device. Use setDevice(0) instead.

### version

    public final int version()

  Returns the version number of the data serialization format.

See also:
  `setVersion()`, and `Version` .

### readBoolean

    public final boolean readBoolean()

  This function reads a boolean from the stream.

### readByte

    public final byte readByte()

  This function read a byte from the stream.

### readShort

    public final short readShort()

  This function reads a short from the stream.

### readInt

    public final int readInt()

  This function reads an int from the stream.

### readLong

    public final long readLong()

  This function reads a long from the stream.

### readChar

    public final char readChar()

  Reads a character from the stream.

### readFloat

    public final float readFloat()

  This function reads a float from the stream.

### readDouble

    public final double readDouble()

  This function read a double from the stream.

### writeShort

    public final QDataStream writeShort(short s)

  This function writes the short `s/tt> to the stream. It returns a reference to the stream after it has been read from.

  `

### readString

    public final java.lang.String readString()

  This function reads a string from the stream.

### writeString

    public final void writeString(java.lang.String string)

  This function writes the short `s/tt> to the stream. It returns a reference to the stream after it has been read from. `string`

  `

### writeBytes

    public final int writeBytes(byte[] buffer)

  Writes the bytes in `data` to the stream, This function returns the bytes written or -1 if an error occurred.

### writeBytes

    public final int writeBytes(byte[] buffer,
                                int length)

  Writes `length` bytes from `data`. The function returns the number of bytes written or -1 if an error occurred.

### readBytes

    public final int readBytes(byte[] buffer)

  Reads data from the stream and puts the data in `buffer`. It returns the number of bytes read or -1 if an error occurred.

### readBytes

    public final int readBytes(byte[] buffer,
                               int length)

  Reads `length` bytes from the stream, and puts them in `buffer`. The method returns the number of bytes read or -1 if an error occurred.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD